<?php
/*
 * Cette classe est utilis pour la cration de module et leur gestion
 *  
 * @file         module.class.php
 * @author       MICHEL Sylvain
 * @version      1.0
 * @since        2002-06-11
 * @project      phpFullAnnu
 * @package      phpFullAnnu
 * @subpackage   I/O
 * @copyright    (C) 2002 MICHEL Sylvain webmaster@netsliver.com
 */

class module {
	var $name;					//nom du module
	var $title;					//titre qui va s'ajouter sur le titre de la page
	var $path;					//chemin vers le fichier  inclure
	var $menu;					//titre pour le menu
	var $vartpl;				//variable du template menu
	var $head;					//variable pour savoir si le head doit tre afficher
	var $metas;					//variable pour savoir si les metas doivent tre afficher
	var $navig;					//variable pour savoir si le module fait parti de la navigation
	var $tplnav;				//variable pour savoir si navig.tpl doit tre afficher
	var $init_error = false;

	//constructeur - initialise un module
	function module( $name, $title, $path, $menu, $vartpl, $head, $metas, $navig, $tplnav ) {
		$this->setName($name);
		$this->title = $title;
		$this->setPath($path);
		$this->menu = $menu;
		$this->vartpl = $vartpl;
		$this->head = $head;
		$this->metas = $metas;
		$this->navig = $navig;
		$this->tplnav = $tplnav;
		if ( !$this->init_error ) {
			$this->tabmod(1);
		}
	}

	//insre l'objet dans le tableau
	function tabmod( $add = 0 ) {
		static $tabmod;
		if ( $add ) {
			$tabmod[$this->name] = $this;
		}
		return $tabmod;
	}

	//affiche les objects
	function printTab() {
		echo '<pre>', print_r($this->tabmod()), '</pre>';
	}
	
	//retourne les objects
	function getTab() {
		return($this->tabmod());
	}
	
	//configure le nom
	function setName( $name ) {
		$tabmod = $this->getTab();	//on recupre le tableau des objets
		if ( !is_array($tabmod) ) {
			$this->name = $name;
			$this->init_error = false;
			return true;
		} else {
			if ( $this->verifName($name) ) {
				$this->name = $name;
				$this->init_error = false;
				return true;
			} else {
				die('The module "'.$name.'" is already exists, you can t redefine this');
				$this->init_error = true;
				return false;
			}
		}
	}
	
	//vrifie si le module existe dj
	function verifName( $name ) {
		$tabmod = $this->getTab();	//on recupre le tableau des objets
		reset($tabmod);
		while ( list($k, $v) = each($tabmod) ) {
			if ( $name == $v->getName() ) {
				return false;
			}
		}
		return true;
	}

	//configure le fichier
	function setPath( $path ) {
		if ( is_file($path) ) {
			$this->path = $path;
			$this->init_error = false;
			return true;
		} else {
			die('You have an error in the path "'.$path.'", the file doesn t exists');
			$this->init_error = true;
			return false;
		}
	}

	//retourne le nom
	function getName() {
		return($this->name);
	}

	//retourne le titre
	function getTitle() {
		return($this->title);
	}

	//retourne le fichier
	function getPath() {
		return($this->path);
	}

	//retourne le titre du menu
	function getMenu() {
		return($this->menu);
	}
	
	//retourne la var du menu
	function getVartpl() {
		return($this->vartpl);
	}
	
	//retourne la var head
	function getHead() {
		return($this->head);
	}
	
	//retourne la var metas
	function getMetas() {
		return($this->metas);
	}
	
	//retourne la var navig
	function getNavig() {
		return($this->navig);
	}
	
	//retourne la var tplnav
	function getTplnav() {
		return($this->tplnav);
	}
}
?>
